/**
 * Generated by @openapi-codegen
 *
 * @version 1.0.0
 */
export type Asteroid = {
  id: number
  /*
   * @pattern ^[-a-zA-Z0-9_]+$
   */
  collection: string
  /*
   * Required. 150 characters or fewer. Letters, digits and @/./+/-/_ only.
   */
  current_owner: string
  /*
   * The name of the organization
   */
  allegiance: string
  most_recent_valuation: string
  spectral_type: string
  /*
   * @maximum 9223372036854776000
   * @minimum 0
   * @format int64
   */
  serial: number
  /*
   * @maxLength 128
   */
  name?: string
  /*
   * @maxLength 1024
   */
  description?: string
  /*
   * @maxLength 256
   */
  image_url?: string
  profile?: string
  /*
   * @maximum 750284
   * @minimum 2046
   */
  diameter?: number | null
  /*
   * @maximum 2147483647
   * @minimum -2147483648
   */
  surface_area?: number | null
  /*
   * @format double
   * @maximum 3.913
   * @minimum 0.89
   */
  semi_major_axis?: number | null
  /*
   * @format double
   * @maximum 0.392
   * @minimum 0.007
   */
  eccentricity?: number | null
  /*
   * @format double
   * @maximum 37.77
   * @minimum 0.01
   */
  inclination?: number | null
  /*
   * @format double
   * @maximum 1000
   * @minimum -1000
   * @exclusiveMaximum true
   * @exclusiveMinimum true
   */
  ascending_node?: number | null
  /*
   * @format double
   * @maximum 1000
   * @minimum -1000
   * @exclusiveMaximum true
   * @exclusiveMinimum true
   */
  anomaly?: number | null
  /*
   * @format double
   * @maximum 1000
   * @minimum -1000
   * @exclusiveMaximum true
   * @exclusiveMinimum true
   */
  periapsis?: number | null
  /*
   * @format double
   * @maximum 10000
   * @minimum 0
   * @exclusiveMaximum true
   */
  orbital_period?: number | null
  /*
   * @maximum 2147483647
   * @minimum -2147483648
   */
  purchase_order?: number
  polymorphic_ctype: number
}

export type CrewClassEnum = -1 | 1 | 2 | 3 | 4 | 5

export type Crewmate = {
  id: number
  /*
   * @pattern ^[-a-zA-Z0-9_]+$
   */
  collection: string
  /*
   * Required. 150 characters or fewer. Letters, digits and @/./+/-/_ only.
   */
  current_owner: string
  /*
   * The name of the organization
   */
  allegiance: string
  most_recent_valuation: string
  /*
   * @maximum 9223372036854776000
   * @minimum 0
   * @format int64
   */
  serial: number
  /*
   * @maxLength 128
   */
  name?: string
  /*
   * @maxLength 1024
   */
  description?: string
  /*
   * @maxLength 256
   */
  image_url?: string
  profile?: string
  /*
   * @maximum 2147483647
   * @minimum -2147483648
   */
  crew_collection?: number
  /*
   * Though the Influence API refers to this as `sex`, we use more inclusive language.
   */
  gender?: GenderEnum
  /*
   * @maximum 2147483647
   * @minimum -2147483648
   */
  body?: number
  /*
   * @minimum -2147483648
   * @maximum 2147483647
   */
  crew_class?: CrewClassEnum
  /*
   * @minimum -2147483648
   * @maximum 2147483647
   */
  title?: TitleEnum
  /*
   * @maximum 2147483647
   * @minimum -2147483648
   */
  outfit?: number
  /*
   * @maximum 2147483647
   * @minimum -2147483648
   */
  hair?: number
  /*
   * @maximum 2147483647
   * @minimum -2147483648
   */
  facial_feature?: number
  /*
   * @maximum 2147483647
   * @minimum -2147483648
   */
  hair_color?: number
  /*
   * @maximum 2147483647
   * @minimum -2147483648
   */
  head_piece?: number
  /*
   * @maximum 2147483647
   * @minimum -2147483648
   */
  bonus_item?: number
  polymorphic_ctype: number
}

export type GenderEnum = 'M' | 'F' | '-'

/**
 * Serializer class used to validate a username and password.
 *
 * 'username' is identified by the custom UserModel.USERNAME_FIELD.
 *
 * Returns a JSON Web Token that can be used to authenticate later calls.
 */
export type JSONWebToken = {
  password: string
  token: string
  username: string
}

export type NFTAsset = {
  id: number
  /*
   * @maximum 9223372036854776000
   * @minimum 0
   * @format int64
   */
  serial: number
  /*
   * The name of the organization
   */
  allegiance: string
  /*
   * @maxLength 128
   */
  name?: string
  /*
   * Required. 150 characters or fewer. Letters, digits and @/./+/-/_ only.
   */
  current_owner: string
  /*
   * @maxLength 256
   */
  image_url?: string
  /*
   * @maxLength 1024
   */
  description?: string
  /*
   * @pattern ^[-a-zA-Z0-9_]+$
   */
  collection: string
}

export type PaginatedAsteroidList = {
  /*
   * @example 123
   */
  count?: number
  /*
   * @format uri
   * @example http://api.example.org/accounts/?offset=400&limit=100
   */
  next?: string | null
  /*
   * @format uri
   * @example http://api.example.org/accounts/?offset=200&limit=100
   */
  previous?: string | null
  results?: Asteroid[]
}

export type PaginatedCrewmateList = {
  /*
   * @example 123
   */
  count?: number
  /*
   * @format uri
   * @example http://api.example.org/accounts/?offset=400&limit=100
   */
  next?: string | null
  /*
   * @format uri
   * @example http://api.example.org/accounts/?offset=200&limit=100
   */
  previous?: string | null
  results?: Crewmate[]
}

export type PaginatedNFTAssetList = {
  /*
   * @example 123
   */
  count?: number
  /*
   * @format uri
   * @example http://api.example.org/accounts/?offset=400&limit=100
   */
  next?: string | null
  /*
   * @format uri
   * @example http://api.example.org/accounts/?offset=200&limit=100
   */
  previous?: string | null
  results?: NFTAsset[]
}

export type PaginatedUserList = {
  /*
   * @example 123
   */
  count?: number
  /*
   * @format uri
   * @example http://api.example.org/accounts/?offset=400&limit=100
   */
  next?: string | null
  /*
   * @format uri
   * @example http://api.example.org/accounts/?offset=200&limit=100
   */
  previous?: string | null
  results?: User[]
}

export type PaginatedWalletList = {
  /*
   * @example 123
   */
  count?: number
  /*
   * @format uri
   * @example http://api.example.org/accounts/?offset=400&limit=100
   */
  next?: string | null
  /*
   * @format uri
   * @example http://api.example.org/accounts/?offset=200&limit=100
   */
  previous?: string | null
  results?: Wallet[]
}

export type PatchedUser = {
  /*
   * Required. 150 characters or fewer. Letters, digits and @/./+/-/_ only.
   *
   * @pattern ^[\w.@+-]+$
   * @maxLength 150
   */
  username?: string
  allegiance?: number | null
}

/**
 * Serializer used for refreshing JWTs.
 */
export type RefreshAuthToken = {
  token: string
}

export type TitleEnum =
  | -1
  | 1
  | 2
  | 3
  | 4
  | 5
  | 6
  | 7
  | 8
  | 9
  | 10
  | 11
  | 12
  | 13
  | 14
  | 15
  | 16
  | 17
  | 18
  | 19
  | 20
  | 21
  | 22
  | 23
  | 24
  | 25
  | 26
  | 27
  | 28
  | 29
  | 30
  | 31
  | 32
  | 33
  | 34
  | 35
  | 36
  | 37
  | 38
  | 39
  | 40
  | 41
  | 42
  | 43
  | 44
  | 45
  | 46
  | 47
  | 48
  | 49
  | 50
  | 51
  | 52
  | 53
  | 54
  | 55
  | 56
  | 57
  | 58
  | 59
  | 60
  | 61
  | 62
  | 63
  | 64
  | 65

export type User = {
  /*
   * Required. 150 characters or fewer. Letters, digits and @/./+/-/_ only.
   *
   * @pattern ^[\w.@+-]+$
   * @maxLength 150
   */
  username: string
  allegiance?: number | null
}

export type Wallet = {
  blockchain: number
  /*
   * @maxLength 96
   */
  address: string
}
